"""
Optimizer plugins for DNADNA.

The base implementation provides support for all of the built-in optimizers and schedulers
from `torch.optim`.
"""

from torch import optim as torch_optim
from torch.optim import lr_scheduler

from .utils.plugins import Pluggable
from .utils.torch_plugin_mixin import TorchPluginMixin

# These are special cases for some of the Optimizers that don't conform to the
# general assumptions of the schemas generated by Optimizer.from_torch.
# These need to be updated on a case-by-case basis if new PyTorch Optimizers
# are added.
_OPTIMIZER_SCHEMA_OVERRIDES = {
    'LBFGS': {
        'properties': {
            'history_size': {'type': 'integer'},
            'line_search_fn': {
                'type': ['null', 'string'],
                'oneOf': [
                    {'type': 'null'},
                    {'type': 'string', 'enum': ['strong_wolfe']}
                ]
            }
        }
    }
}

# Same for LRScheduler, and this one is a bit more complicated beause many of
# the LRScheduler classes have __init__ arguments that don't have default
# values, so until pytorch has built-in type annotations there is no way for
# the automatic schema generator to guess the correct types for these
# parameters
_LR_SCHEDULER_SCHEMA_OVERRIDES = {

    # 'MultiplicativeLR': {

    # },
    'StepLR': {
        'properties': {
            'step_size': {'type': 'integer', 'minimum': 1}
        }
    },
    'MultiStepLR': {
        'properties': {
            # List of epoch indices; must be increasing (there is no way to
            # guarantee the increasing property from the schema alone)
            'milestones': {
                'type': 'array',
                'items': {'type': 'integer', 'minimum': 0}
            }
        }
    },
    'ExponentialLR': {
        'properties': {
            'gamma': {'type': 'number'}
        }
    },
    'CosineAnnealingLR': {
        'properties': {
            'T_max': {'type': 'number'}
        }
    },
    # SequentialLR is an interesting one, because like ChainedScheduler it
    # takes an array of sub-schedulers as one of its argumnets
    'SequentialLR': {
        'properties': {
            'schedulers': {
                'type': 'array',
                'minItems': 1,
                'items': {'$ref': 'py-obj:dnadna.schemas.plugins.lr_scheduler'}
            },
            'milestones': {
                'description':
                    'List of epoch indices at which to switch which scheduler '
                    'is used--must be the same length as the schedulers param',
                'type': 'array',
                'minItems': 1,
                'items': {'type': 'integer', 'minimum': 0}
            }
        }
    },
    'CyclicLR': {
        'definitions': {
            'floatOrListOfFloats': {
                'oneOf': [
                    {'type': 'number'},
                    {'type': 'array', 'minItems': 1, 'items': {'type': 'number'}}
                ]
            }
        },
        'properties': {
            'base_lr': {'$ref': '#/definitions/floatOrListOfFloats'},
            'max_lr': {'$ref': '#/definitions/floatOrListOfFloats'}
        }
    },
    'OneCycleLR': {
        'properties': {
            'max_lr': {'$ref': 'py-obj:dnadna.schemas.plugins.lr_scheduler'
                               '.cyclic_lr#/definitions/floatOrListOfFloats'},
            'total_steps': {'type': ['null', 'integer'], 'default': None},
            'epoch': {'type': ['null', 'integer'], 'default': None},
            'steps_per_epoch': {'type': ['null', 'integer'], 'default': None}
        }
    },
    'CosineAnnealingWarmRestarts': {
        'properties': {
            'T_0': {'type': 'integer'}
        }
    }
}


class Optimizer(torch_optim.Optimizer, TorchPluginMixin, Pluggable):
    """
    Subclasses `torch.optim.Optimizer` adding support for DNADNA's plugin
    interface.

    This allows creating new optimizers that can be used in DNADNA.  It also
    makes all of PyTorch's built-in optimizers available for use in DNADNA
    (though not all have been tested).
    """

    fixed_params = {'params'}
    param_aliases = {'learning_rate': 'lr'}
    """
    Maps optimizer parameters read from the DNADNA config file to the
    corresponding keyword argument name for the Optimizer's initializer.

    In particular, the optimizers in `torch.optim` all take an argument called
    ``lr`` for learning rate, but we also allow ``learning_rate``.
    """
    schema = {
        'properties': {
            'lr': {'type': 'number'}
        }
    }


class LRScheduler(torch_optim.lr_scheduler.LRScheduler, TorchPluginMixin,
                  Pluggable):
    fixed_params = {'optimizer'}


# Special case: ChainedScheduler is not automatically registered because the
# class in PyTorch doesn't take the same __init__ args as the others.  That is,
# it does not take the optimizer as its first argument.  This seems
# mis-designed to me, because SequentialLR is similar, but *does* take an
# optimizer argument for compatibility.  Here we provide a wrapper to make it
# compatible with the other schedulers.
#
# NOTE: PyTorch added ChainedScheduler only in v1.10, so check if it actually
# exists.  We could also provide our own copy of this for backwards
# compatibility, as the implementation is simple-enough. but it's omitted for
# now.
if hasattr(torch_optim.lr_scheduler, 'ChainedScheduler'):
    class ChainedScheduler(lr_scheduler.ChainedScheduler, LRScheduler):
        """
        Configured with an array of scheduler configs, like::

            lr_scheduler:
              name: chained_scheduler
              params:
                schedulers:
                  - name: constant_lr
                    params:
                      factor: 0.1
                  - name: exponential_lr
                    params:
                      gamma: 0.9
        """
        schema = {
            'properties': {
                'schedulers': {
                    'type': 'array',
                    'minItems': 1,
                    'items': {'$ref': 'py-obj:dnadna.schemas.plugins.lr_scheduler'}
                }
            }
        }

        def __init__(self, optimizer, schedulers):
            for scheduler in schedulers:
                if scheduler.optimizer != optimizer:
                    raise ValueError(
                        f'{self.__class__.__name__} expects all chained '
                        f'schedulers to belong to the same optimizer, but '
                        f'{scheduler} has a different optimizer')

            super().__init__(schedulers)


def _validate_lr_lambda(lr_lambda):
    if isinstance(lr_lambda, str):
        lr_lambda = [lr_lambda]
    try:
        return [eval(expr) for expr in lr_lambda]
    except Exception as e:
        raise ValueError(f"Invalid lr_lambda expression(s): {lr_lambda}. Error: {e}")


class LambdaLR(lr_scheduler.LambdaLR, LRScheduler):
    """
    Wrapper for PyTorch's LambdaLR scheduler.

    Configured with a scheduler config, like::

        lr_scheduler:
          name: lambda_lr
          params:
            lr_lambda: 'lambda epoch: 0.95 ** epoch'
    """
    schema = {
        'properties': {
            'lr_lambda': {
                'type': 'string',
                'description': 'A single function that computes a multiplicative factor '
                               'given an integer parameter epoch. Must be a valid lambda '
                               'expression.',
                'examples': 'lambda epoch: epoch * 0.95'
            },
        },
        'required': ['lr_lambda']
    }

    def __init__(self, optimizer, lr_lambda):
        super().__init__(optimizer, _validate_lr_lambda(lr_lambda))


class MultiplicativeLR(lr_scheduler.LambdaLR, LRScheduler):
    """
    Wrapper for PyTorch's LambdaLR scheduler.

    Configured with a scheduler config, like::
        lr_scheduler:
          name: multiplicative_lr
          params:
            lr_lambda:
                - 'lambda epoch: 0.95 ** epoch'
                - 'lambda epoch: 0.9 if epoch < 10 else 0.8'

    """
    schema = {
        'properties': {
            'lr_lambda': {
                'oneOf': [
                    {
                        'type': 'string',
                        'description': 'A single function that computes a '
                                       'factor given an integer parameter epoch. Must be a '
                                       'valid lambda expression.',
                        'examples': 'lambda epoch: epoch * 0.95'
                    },
                    {
                        'type': 'array',
                        'description': 'A list of functions which compute multiplicative '
                                       'factors given an integer parameter epoch. '
                                       'Each function must be a valid lambda expression.',
                        'items': {
                            'type': 'string',
                            'examples': [
                                'lambda epoch: epoch * 0.95',
                                'lambda epoch: 0.95 if epoch < 10 else 0.90'
                            ]
                        }
                    }
                ]
            }
        },
        'required': ['lr_lambda']
    }

    def __init__(self, optimizer, lr_lambda):
        super().__init__(optimizer, _validate_lr_lambda(lr_lambda))


# Register all Optimizers included in torch.optim as available optimizers.
# As flexible as Optimizer.from_torch is, there are still a handful of special
# cases represented in _SCHEMA_OVERRIDES
def _register_plugins(plugin_cls, torch_module, torch_basecls, overrides={},
                      omit=()):
    for name, value in vars(torch_module).items():
        if (isinstance(value, type) and issubclass(value, torch_basecls) and
                value is not torch_basecls and name not in omit):
            # e.g. given plugin_cls=Optimizer, torch_module=torch.optim,
            # torch_basecls=torch.optim.Optimizer, this will give all strict
            # subclasses of torch.optim.Optimizer
            globals()[name] = plugin_cls.from_torch(value,
                                                    overrides.get(name, {}))


_register_plugins(Optimizer, torch_optim, torch_optim.Optimizer,
                  _OPTIMIZER_SCHEMA_OVERRIDES)
# We to omit LambdaLR and MultiplicativeLR because they use lambdas functions
# for their learning rate schedules, which are not JSON-serializable.
# ChainedScheduler need a redefine because it doesn't take the same arguments
# as the other schedulers
_register_plugins(LRScheduler, torch_optim.lr_scheduler,
                  torch_optim.lr_scheduler.LRScheduler,
                  _LR_SCHEDULER_SCHEMA_OVERRIDES,
                  omit=['LambdaLR', 'MultiplicativeLR', 'ChainedScheduler', '_LRScheduler'])
